package com.zcxk.dao;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zcxk.dto.OrgBaseTreeInfoDto;
import com.zcxk.dto.OrgTree;
import com.zcxk.entity.Org;
import com.zcxk.model.ProgramItem;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 组织(Org)表数据库访问层
 *
 * @author makejava
 * @since 2020-10-26 14:55:43
 */
@Mapper
public interface OrgMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Org selectById(Integer id);


    /**
     * 查询全部
     *
     * @return 对象列表
     */
    List<Org> selectAll();

    /**
     * 通过实体作为筛选条件查询
     *
     * @param org 实例对象
     * @return 对象列表
     */
    List<Org> selectList(Org org);

    /**
     * 新增数据
     *
     * @param org 实例对象
     * @return 影响行数
     */
    int insert(Org org);

    /**
     * 批量新增
     *
     * @param orgs 实例对象的集合
     * @return 影响行数
     */
    int batchInsert(List<Org> orgs);

    /**
     * 修改数据
     *
     * @param org 实例对象
     * @return 影响行数
     */
    int update(Org org);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 查询总数据数
     *
     * @return 数据总数
     */
    int count();

    IPage<Org> selectPage(IPage<Org> page, Org org);
    Org findOrgUser(Org org);
    Org findOrgType(Org org);


    List<OrgTree> selectTrees(Org org);

    List<Org> findOrgByTenant(String tenantId);

    String findParentOrgByChildId(@Param(value = "childId") Integer childId);

    Integer countCompanyByUser( @Param("tenantId")String tenantId, @Param("userType")String userType,
                                @Param("programItems")List<ProgramItem> programItems);
    List<OrgBaseTreeInfoDto> getCompanyByUser(@Param("condition")String condition,@Param("companyIds")List<Integer> companyIds, @Param("tenantId")String tenantId, @Param("userType")String userType,
                                              @Param("programItems")List<ProgramItem> programItems);

}